function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/* eslint-disable @typescript-eslint/no-parameter-properties */
/* eslint-disable @typescript-eslint/parameter-properties */
import { syntaxTree } from '@codemirror/language';
import { Annotation, EditorSelection } from '@codemirror/state';

/// Objects type used to represent individual completions.

/// An instance of this is passed to completion source functions.
export var CompletionContext = /*#__PURE__*/function () {
  /// Create a new completion context. (Mostly useful for testing
  /// completion sources—in the editor, the extension will create
  /// these for you.)
  function CompletionContext(
  /// The editor state that the completion happens in.
  state,
  /// The position at which the completion is happening.
  pos,
  /// Indicates whether completion was activated explicitly, or
  /// implicitly by typing. The usual way to respond to this is to
  /// only return completions when either there is part of a
  /// completable entity before the cursor, or `explicit` is true.
  explicit) {
    _classCallCheck(this, CompletionContext);
    this.state = state;
    this.pos = pos;
    this.explicit = explicit;
    /// @internal
    this.abortListeners = [];
  }

  /// Get the extent, content, and (if there is a token) type of the
  /// token before `this.pos`.
  _createClass(CompletionContext, [{
    key: "tokenBefore",
    value: function tokenBefore(types) {
      var token = syntaxTree(this.state).resolveInner(this.pos, -1);
      while (token && types.indexOf(token.name) < 0) {
        token = token.parent;
      }
      return token ? {
        from: token.from,
        to: this.pos,
        text: this.state.sliceDoc(token.from, this.pos),
        type: token.type
      } : null;
    }

    /// Get the match of the given expression directly before the
    /// cursor.
  }, {
    key: "matchBefore",
    value: function matchBefore(expr) {
      var line = this.state.doc.lineAt(this.pos);
      var start = Math.max(line.from, this.pos - 250);
      var str = line.text.slice(start - line.from, this.pos - line.from);
      var found = str.search(ensureAnchor(expr, false));
      return found < 0 ? null : {
        from: start + found,
        to: this.pos,
        text: str.slice(found)
      };
    }

    /// Yields true when the query has been aborted. Can be useful in
    /// asynchronous queries to avoid doing work that will be ignored.
  }, {
    key: "aborted",
    get: function get() {
      return this.abortListeners === null;
    }

    /// Allows you to register abort handlers, which will be called when
    /// the query is
    /// [aborted](#autocomplete.CompletionContext.aborted).
  }, {
    key: "addEventListener",
    value: function addEventListener(type, listener) {
      if (type === 'abort' && this.abortListeners) {
        this.abortListeners.push(listener);
      }
    }
  }]);
  return CompletionContext;
}();
function toSet(chars) {
  var flat = Object.keys(chars).join('');
  var words = /\w/.test(flat);
  if (words) {
    flat = flat.replace(/\w/g, '');
  }
  return "[".concat(words ? '\\w' : '').concat(flat.replace(/[^\w\s]/g, '\\$&'), "]");
}
function prefixMatch(options) {
  var first = Object.create(null),
    rest = Object.create(null);
  var _iterator = _createForOfIteratorHelper(options),
    _step;
  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var label = _step.value.label;
      first[label[0]] = true;
      for (var i = 1; i < label.length; i++) {
        rest[label[i]] = true;
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
  var source = toSet(first) + toSet(rest) + '*$';
  return [new RegExp('^' + source), new RegExp(source)];
}

/// Given a a fixed array of options, return an autocompleter that
/// completes them.
export function completeFromList(list) {
  var options = list.map(function (o) {
    return typeof o === 'string' ? {
      label: o
    } : o;
  });
  var _ref = options.every(function (o) {
      return /^\w+$/.test(o.label);
    }) ? [/\w*$/, /\w+$/] : prefixMatch(options),
    _ref2 = _slicedToArray(_ref, 2),
    validFor = _ref2[0],
    match = _ref2[1];
  return function (context) {
    var token = context.matchBefore(match);
    return token || context.explicit ? {
      from: token ? token.from : context.pos,
      options: options,
      validFor: validFor
    } : null;
  };
}

/// Wrap the given completion source so that it will only fire when the
/// cursor is in a syntax node with one of the given names.
export function ifIn(nodes, source) {
  return function (context) {
    for (var _pos = syntaxTree(context.state).resolveInner(context.pos, -1); _pos; _pos = _pos.parent) {
      if (nodes.indexOf(_pos.name) > -1) {
        return source(context);
      }
    }
    return null;
  };
}

/// Wrap the given completion source so that it will not fire when the
/// cursor is in a syntax node with one of the given names.
export function ifNotIn(nodes, source) {
  return function (context) {
    for (var _pos2 = syntaxTree(context.state).resolveInner(context.pos, -1); _pos2; _pos2 = _pos2.parent) {
      if (nodes.indexOf(_pos2.name) > -1) {
        return null;
      }
    }
    return source(context);
  };
}

/// The function signature for a completion source. Such a function
/// may return its [result](#autocomplete.CompletionResult)
/// synchronously or as a promise. Returning null indicates no
/// completions are available.

/// Interface for objects returned by completion sources.

export var Option = /*#__PURE__*/_createClass(function Option(completion, source, match) {
  _classCallCheck(this, Option);
  this.completion = completion;
  this.source = source;
  this.match = match;
});
export function cur(state) {
  return state.selection.main.head;
}

// Make sure the given regexp has a $ at its end and, if `start` is
// true, a ^ at its start.
export function ensureAnchor(expr, start) {
  var _expr$flags;
  var source = expr.source;
  var addStart = start && source[0] !== '^',
    addEnd = source[source.length - 1] !== '$';
  if (!addStart && !addEnd) {
    return expr;
  }
  return new RegExp("".concat(addStart ? '^' : '', "(?:").concat(source, ")").concat(addEnd ? '$' : ''), (_expr$flags = expr.flags) !== null && _expr$flags !== void 0 ? _expr$flags : expr.ignoreCase ? 'i' : '');
}

/// This annotation is added to transactions that are produced by
/// picking a completion.
export var pickedCompletion = Annotation.define();

/// Helper function that returns a transaction spec which inserts a
/// completion's text in the main selection range, and any other
/// selection range that has the same text in front of it.
export function insertCompletionText(state, text, from, to) {
  return _objectSpread(_objectSpread({}, state.changeByRange(function (range) {
    if (range === state.selection.main) {
      return {
        changes: {
          from: from,
          to: to,
          insert: text
        },
        range: EditorSelection.cursor(from + text.length)
      };
    }
    var len = to - from;
    if (!range.empty || len && state.sliceDoc(range.from - len, range.from) !== state.sliceDoc(from, to)) {
      return {
        range: range
      };
    }
    return {
      changes: {
        from: range.from - len,
        to: range.from,
        insert: text
      },
      range: EditorSelection.cursor(range.from - len + text.length)
    };
  })), {}, {
    userEvent: 'input.complete'
  });
}
export function applyCompletion(view, option) {
  var apply = option.completion.apply || option.completion.label;
  var result = option.source;
  if (typeof apply === 'string') {
    view.dispatch(insertCompletionText(view.state, apply, result.from, result.to));
  } else {
    apply(view, option.completion, result.from, result.to);
  }
}
var SourceCache = new WeakMap();
export function asSource(source) {
  if (!Array.isArray(source)) {
    return source;
  }
  var known = SourceCache.get(source);
  if (!known) {
    SourceCache.set(source, known = completeFromList(source));
  }
  return known;
}